#!/bin/sh
#======================================================
#KB8300.sh
#======================================================
#=== SET PARAMETER ====================================

#-- Garoon DB INSTALL PATH  MySQLのインストールディレクトリ
GRN_PATH="/usr/local/cybozu"

#-- Garoon INSTALL CODE ガルーンの識別子
GRN_CODE="cbgrn"

#-- Database User MySQLに接続するユーザー
DB_USER="cbroot"

#-- Database PASSWORD MySQLに接続するユーザーのパスワード
DB_PASS="cybozu"

#-- Database HOST DBサーバーのIPアドレス（DB分割構成の場合はメールを割り振っているDBサーバーのIPアドレスを指定してください）
DB_HOST="127.0.0.1"

#-- Database PORT  MySQLのポート番号
DB_PORT="3770"


#======================================================












#=== FLUSH VALIABLES ==================================
#-- TGT_TABLE
TGT_TABLE=""
MYSQL_PATH="${GRN_PATH}/mysql-5.0/bin/mysql"

#-- SHELL_DIRECTORY
SCRIPT_DIR=`dirname $0`

#-- TEMP_FILE_NAME
SEND_MAIL_FILE=sendmail.txt
ERROR_MAIL_DETAIL_FILE=MailList.txt

#-- CLEAR_TEMP_FILE
cat /dev/null > "$SCRIPT_DIR"/"$SEND_MAIL_FILE"
cat /dev/null > "$SCRIPT_DIR"/"$ERROR_MAIL_DETAIL_FILE"

#======================================================


#==== FUNCTIONS =======================================
#-------------------
# func_GetInformationSchema_Table_division
#     $1 : table prefix
#     $2 : start table number
#     $3 : end table number
#-------------------
func_GetSendMailData ()
{
    i=0
    
    for i in `seq "$2" "$3"`
    do
        #_STR="SELECT _id,col_to,col_cc,col_bcc,col_user FROM $1$i WHERE col_sent=1 AND col_draft is null;"
        _STR="SELECT DISTINCT msg._id,msg.col_to,msg.col_cc,msg.col_bcc,msg.col_user FROM $1$i AS msg LEFT JOIN tab_grn_mail_sourcefilebody___p$i AS sr ON msg._id = sr.col_mail WHERE sr.col_mail IS NULL AND msg.col_draft IS NULL"
        #echo "$_STR"
        _TMP=`"$MYSQL_PATH" -u "$DB_USER" -p"$DB_PASS" -h "$DB_HOST" -P "$DB_PORT" -A -D cb_"$GRN_CODE" -Ne "$_STR" >> "$SCRIPT_DIR"/"$SEND_MAIL_FILE"` 
        echo `date +"%Y/%m/%d %T"`" : Finish Table :tab_grn_mail_message___p$i"
    done
}


#-------------------
# func_GetErrorMailInformation
#     $1 : File Path
#-------------------
func_GetErrorMailInformation()
{
    echo -e "メールタイトル\tFrom:\tTo:\tCc:\tBcc:\tメールが送信された日時\tメールを所持するユーザー\tメールを所持するユーザーのID\tメールID\t未読/既読\t"  >> "$SCRIPT_DIR"/"$ERROR_MAIL_DETAIL_FILE"
    cat "$1" | while read LINE
    do
        #convert consecutive tab
        NA_VALUE=\"na\"
        LINE=`echo "$LINE" | sed "s/\t\t\t/\t$NA_VALUE\t$NA_VALUE\t/g"`
        LINE=`echo "$LINE" | sed "s/\t\t/\t$NA_VALUE\t/g"`

        #_id,col_to,col_cc,col_bcc,col_user
        IFS=`echo -e '\t'`
        SEND_MAIL_ARRAY=(`echo "$LINE"`)
        unset IFS

        MAIL_ID="${SEND_MAIL_ARRAY[0]}"
        USER_ID="${SEND_MAIL_ARRAY[4]}"
        TABLE_ID=`expr "$USER_ID" % 50`

        #msg.col_subject, msg.col_from, msg.col_to, msg.col_cc, msg.col_bcc, msg.col_send_ts, usr.col_display_name, msg.col_user, msg._id 
        _STR="SELECT msg.col_subject, msg.col_from, msg.col_to, msg.col_cc, msg.col_bcc, msg.col_send_ts, usr.col_display_name, msg.col_user, msg._id, msg.col_read_ts FROM tab_grn_mail_message___p$TABLE_ID AS msg INNER JOIN tab_cb_user AS usr ON msg.col_user = usr._id WHERE msg._id=$MAIL_ID;" 
        _TMP=`"$MYSQL_PATH" -u "$DB_USER" -p"$DB_PASS" -h "$DB_HOST" -P "$DB_PORT" -A -D cb_"$GRN_CODE" -Ne "$_STR"` 

        
        NA_VALUE='"-"'

        _TMP=`echo "$_TMP" | sed "s/^\t/$NA_VALUE\t/g"`
        _TMP=`echo "$_TMP" | sed "s/\t\t\t/\t$NA_VALUE\t$NA_VALUE\t/g"`
        _TMP=`echo "$_TMP" | sed "s/\t\t/\t$NA_VALUE\t/g"`

        IFS=`echo -e '\t'`
        RESULT_ARRAY=(`echo "$_TMP"`)
        unset IFS

        LENGTH_RESULT_ARRAY=`expr ${#RESULT_ARRAY[*]} - 1`
        LINE_OUT=""

        #check each field
        for i in `seq 0 "$LENGTH_RESULT_ARRAY"`
        do
            if [ "$i" -eq 0 -a "${RESULT_ARRAY[$i]}" = "$NA_VALUE" ] ; then
                #replace no title
                RESULT_ARRAY[$i]="\"（無題）\""
                LINE_OUT="$LINE_OUT""${RESULT_ARRAY[$i]}"`echo -e "\t"`
            elif [ "$i" -eq 5 ] ; then
                #replace ts to datetime
                DATE_STR="@${RESULT_ARRAY[$i]}"
                RESULT_ARRAY[$i]=`date -d "$DATE_STR" +"%Y/%m/%d %T"`
                LINE_OUT="$LINE_OUT""${RESULT_ARRAY[$i]}"`echo -e "\t"`
            elif [ "$i" -eq 9 ] ; then
                if [ "${RESULT_ARRAY[$i]}" -eq 0 ]; then
                    RESULT_ARRAY[$i]="\"未読\""
                    LINE_OUT="$LINE_OUT""${RESULT_ARRAY[$i]}"`echo -e "\t"`
                else
                    RESULT_ARRAY[$i]="\"既読\""
                    LINE_OUT="$LINE_OUT""${RESULT_ARRAY[$i]}"`echo -e "\t"`
                fi
            else
                LINE_OUT="$LINE_OUT""${RESULT_ARRAY[$i]}"`echo -e "\t"`
            fi
        done
        echo "$LINE_OUT" >> "$SCRIPT_DIR"/"$ERROR_MAIL_DETAIL_FILE"
    done
    
}

#======================================================


#=== < MAIN > =========================================

echo `date +"%Y/%m/%d %T"`" : Start Script"
echo 

#Check mysql
if test -e "$MYSQL_PATH";then
    cat /dev/null
else
    echo "  ERROR: Can't find mysql "
    echo "       : Please check mysql install path. "
    echo "       : ${MYSQL_PATH}. "
    exit 1
fi


echo `date +"%Y/%m/%d %T"`" : Start GET MAIL DATA"

#Get send mail data with csv file format( SendMailFile )
func_GetSendMailData "tab_grn_mail_message___p" "0" "49"

echo `date +"%Y/%m/%d %T"`" : Finish GET MAIL DATA"
echo 

ERROR_MAIL_NUMBER=(`wc -l "$SCRIPT_DIR"/"$SEND_MAIL_FILE"`)
echo `date +"%Y/%m/%d %T"`" : 添付ファイル（メールソース）が削除されている可能性のあるメールが \""${ERROR_MAIL_NUMBER[0]}"\" 件見つかりました"
echo 

echo `date +"%Y/%m/%d %T"`" : Start GET MAIL DETAIL"
echo 
#Get error mail informaiton
func_GetErrorMailInformation "$SCRIPT_DIR"/"$SEND_MAIL_FILE"

echo `date +"%Y/%m/%d %T"`" : Finish GET MAIL DETAIL"
echo 

\rm -f "$SCRIPT_DIR"/"$SEND_MAIL_FILE"

echo `date +"%Y/%m/%d %T"`" : Finish SCRIPT"


#======================================================
